#pragma once

#include "Buffer.h"

#define FILE_RECORD_DIRECT	0

class CFileRecord
{
public:
	CFileRecord(DWORD dwWriteBlockSize=FILE_RECORD_DIRECT);
	~CFileRecord(void);

	BOOL Open(char *lpszPath);
	void Close();
	BOOL IsOpen();
	DWORD GetOpenTick();
	ULARGE_INTEGER GetFreeSize();
	BOOL Write(void *lpData,DWORD dwDataSize,DWORD *lpdwWritten=NULL);
	unsigned __int64 GetWriteTotalSize()
	{
		return m_ui64WriteSizeTotal;
	}

	static BOOL GetRecordFileName(HWND hParentWnd,char *lpszPath,int nMaxPath);
	static void CheckExistAndRename(char *lpszPath);

protected:
	CBuffer *m_pBuf;
	char m_pDir[MAX_PATH];
	char m_pFile[MAX_PATH];
	HANDLE m_hFile;
	DWORD m_dwBlockWriteSize;
	DWORD m_dwRecordStartTick;
	unsigned __int64 m_ui64WriteSizeTotal;

	BOOL _WriteBlock(DWORD dwWriteSize,DWORD *lpdwWritten);
};
